😊 Good to See you back on UA-cam [ after a long break ] .... And yes this video is really Quality content [ with Lots of Varity on Questions ] thanks for the video
programming becoming more widely available and newbies like myself find your methods of teaching very easily absorbing into my brain cells, I thank you for your great and entertaining content and deep knowledge on DP.
for me the hardest part of DP is finding out that this is a Dp problem . btw you repeatedly said rows in place of column and vice versa many times , other than that it was perfect !
If the problem can be solved by solving subproblems, the problem is most likely a dp question. If the solution to the current subproblem cannot be solved using previous subproblems, then the question is most likely not a dp question. dp intuition requires practice.
A non-dp solution to problem G #include #include using namespace std; typedef long long ll; int main(){ ll v1, v2; cin >> v1 >> v2; ll t, d; cin >> t >> d; ll ans = v1 + v2; for(ll i=1; i
Great video. I tried my best to follow and understand the concepts. Just one suggestion, if you can use better variable names to represent DP states. Using variable names like i, j and k can be confusing sometimes. I know you are used to using shorter names since it's way convenient and fast for CP but I will really appreciate if you could use slightly longer and meaningful names, of course only during explanation for better understanding and avoiding any confusion. Again thanks for great explanation. Really appreciate the time you have taken to explain the DP concepts.
I have no idea what complete dynamic programming is, nor do I ever imagine I'll ever learn, but I did somehow wake up at 3am from a very bizzare dream about it due to youtube's autoplay. So thanks youtube for the 3am lesson that I didn't ask for.
I fell asleep listening to a podcast and then this came on afterwards. I had anxiety dreams I was in college again, and you were trying to teach me differential equations, but nothing you said made any sense because this isn't a class on DE.
I am soo glad that you are making a video on graphs .It will be lot more helpful to many people if you make videos on problems involving greedy method like u made for topics such as trees, dynamic programming . Like where we need to use this approach. We have very less videos regarding this.
I appreciate you putting out this free educational content, but a suggestion would be to try to stay focused while explaining your thought process. It's hard to follow along when mid-thought you reply to chat :(
Dreamed of this annoying know-it-all from my previous job He was "teaching" me things I already knew He said "now I'm gonna teach you recursion" And I replied I ALREADY KNOW WHAT THAT IS And he flat out ignored me Then he said "okay to learn recursion we're gonna use fibonacci's sequence. but first let's learn what fibonacci's sequence is" I was like NO I KNOW WHAT IT IS but again he ignored me Eventually I was fed up so I left the room But he CALLED ME and kept explaining fibonacci's sequence Then I woke up and found out UA-cam was playing this random programming tutorial
So I just realized something after see you do Mashup B. One of the big parts of my struggle with DP questions is understanding what the heck the question is really asking. I saw the solution to the number of typeable substrings for the example string "abacaba" is 12, and I could not see how there are 12 substrings. I could only count 5: a ab aba ba b I couldn't fathom how there's 12 until like the next day I took a look again and it occurred to me that they're counting the same character multiple times if it's in the string in different places. So they're not looking for the count of unique substrings, which was pretty counterintuitive for me
Thanks for these vids man! One suggestion - The audio quality is a dampener to the amazing efforts you're putting in. If it's a short video, it's bearable, but in long streams like these, audio is actually way more important than video. If you could invest a bit in a better mic, it would do a world of good to up the quality of audio. Thanks again for your efforts and value addition to the community. Learning a ton from you!
I incredibly doubt you will see this due to the fact that you apparently have a ton of subscribers all of a sudden, but thought you'd get a kick out of me having found this video through autoplay while asleep, you can imagine my surprise when I woke up and I heard a voice I recognized.
FFT is not DP. It uses the decimation algorithm because so many of the elements end up being zeros. It can be 'memoized' but to break it up into smaller subproblems doesn't give any benefit.
I slept with UA-cam on and this video started playing. I dreamt about a guy who was solving the Navier Stokes millennium equation using some sort of toy that he moves around with his fingers (that was you typing). Lmao
In problem A, f(n) = 2f(n-2) because we choose a 2x3 block (which has 2 orientations) and multiply with the solution of f(n-2), hence 2f(n-2). But we can also chose that 2x3 block in n ways, so why isn't the relation f(n) = n*2*f(n-2) ?
Because the location of the block is irrelevant - if you put it somewhere in the middle, it'll be equivalent to putting it in the middle later (i.e. the order in which you place down blocks is irrelevant). So that recurrence will drastically overcount. I use the recurrence I do to make the subproblems independent - if I place it at the (right) end of the current grid, then it will be completely independent from the rest of the grid, and thus not overcount.
theres very very very little amount of resources on the internet that help people from 0-100 with constructive resources and telling them what to drill and practice.
@Colin Galen In problem E(office keys) Can you please help me in formally proving that the greedy way of having continuous assignment between the keys and people is optimum. Anyone's help would be really useful.
Lets say P1 and P2 are positions of two people and k1 and k2 are positions of two Keys I am going to explain one of the case when k1>P1 and k2 > P2, other 3 cases you can deduce by yourself Distance if we assign P1 to k2 and P2 to k1 is K2-P1 + (p2-k1) if we assume P2> k1 Surely this dis is greater than K1-p1 + (p2-k2) because P2>k1 Other cases you can prove similarly
Hi Colin, In problem E-Office Keys, I understand why you say two people can't cross their paths to get the keys. But you didn't say why you choose key positions continuously. I mean if first person is assigned to ith key position, second person is assigned to (i+1)th position and so on. What is the reason for this ?
i do not understand the dth question in that we can keep him awake for k straight minutes and if we choose start of 3 then we can keep him awake till [3,3+3-1] which includes 5 2 5 so the sum is 12 but how sum is coming as 14 please help ?
Hello, in the past couple of days my internet started acting very strange, my lights are a solid green and a blinking orange but whenever i try to play an online game i keep getting disconnected but the little icon in the right corner still says in connected, how can i fix this?
Why? It's his channel, he has the complete freedom to do streams the way he deems it fun as well as informative. It's no easy task doing a 4hr streaming without taking much of a break.
@@pleasesirmorevideos4684 lol...couldn't you just avoid reading my comment? So distracting, wasn't it? I highly doubt your ability to do what you just said.
I am not comfortable using push dp. Is it ok to use recursive dp. I mean are there any questions which can be done by push dp and not with recursive dp?
Yes, there are some. However, they usually involve difficult recurrences, and won't show up until the higher end of the difficulty scale. In almost all cases, it's completely fine to use recursive DP, and whatever you use is preference. By the time you get to the point of having to solve the harder ones, you'll probably be comfortable enough with DP to be able to do it.
Bro I love your explanations but either stop doing live streams or don't talk to chat in the middle of a solution. Because when i watch recording out of 40 mins of a solution 20 mins is just random talks and its too annoying for us. Read chats when you switch between questions but not otherwise.
This problem set is awful. Four problems in and none of them actually required dynamic programming to find a solution. In fact, all of them could be solved faster by paying attention and thinking the problem thru.
Seems like this video is hitting the algorithm. For those of you who are new here - I have a face now, and also a significantly better mic :)
😊 Good to See you back on UA-cam [ after a long break ] ....
And yes this video is really Quality content [ with Lots of Varity on Questions ]
thanks for the video
.lm
.
.
..
.
.
....
.
..
.
..
.
.
...
.
.
..
.
.
.
.
.
.
.
.
.
.....
....
..
........
.
.
..
.
.
.
.
..
.
.
.
..
.
.
.
...
.
.
..
.....
O
...
.....
.
.
.
.
.
...
.....
....
..
...
.
.
.
.
.
.
...
....
.....
..
..
..
.
.
.
.
..
..
..
.. mm..
...
......
......
.
.
..
..
..
.
...
.
.
M................
.
.
.....
..
..
.....
.
.........
....
....
.
.
..
.......
.
...
.
.......
...
.
.
...
.................
..
Honestly the best tutorial I've seen for DP. I'm working through the problems and referring back to this vid as I get stuck, making progress :)
programming becoming more widely available and newbies like myself find your methods of teaching very easily absorbing into my brain cells, I thank you for your great and entertaining content and deep knowledge on DP.
I am 19 :) still watching you learn something. One suggestion my friend please don't get distracted by live comments
lol didnt expect u here
@@Code_Note brooooo my school kanishk i too do cp a bit bro connect up you on linkedin or discord
@@sayantansinharay9161 ok
I am 19 too 😢
🎉❤@@Code_Note😂❤😂
for me the hardest part of DP is finding out that this is a Dp problem .
btw you repeatedly said rows in place of column and vice versa many times , other than that it was perfect !
exactly😂
For me the hardest part is to identify a greedy problem. I have the least success rate in identifying greedy problems.
If the problem can be solved by solving subproblems, the problem is most likely a dp question. If the solution to the current subproblem cannot be solved using previous subproblems, then the question is most likely not a dp question. dp intuition requires practice.
solution for 1st question
#include
using namespace std;
int pow_2(int n){
return (1n ;
long long x=pow_2(n/2);
if(n%2) cout
"Improving is a random thing"
There are probably a lot of good quotes in this video lol
@@ColinGalen my favorite at 2:10:20
@@harshadaggarwal6029 hahaha
A non-dp solution to problem G
#include
#include
using namespace std;
typedef long long ll;
int main(){
ll v1, v2;
cin >> v1 >> v2;
ll t, d;
cin >> t >> d;
ll ans = v1 + v2;
for(ll i=1; i
For problem F, your original code is almost passing.
if (k>=4) ans += 3 * nck(n,4) + nck(n,2)*nck(n-2,2);
can pass all tests.
Thanks a lot for the contest. Please avoid getting distracted by the comments. Breaks the flow of explanation.
Good Work...First i can try questions on my own and see your video if i get stuck at some problem.
Great video. I tried my best to follow and understand the concepts.
Just one suggestion, if you can use better variable names to represent DP states. Using variable names like i, j and k can be confusing sometimes.
I know you are used to using shorter names since it's way convenient and fast for CP but I will really appreciate if you could use slightly longer and meaningful names, of course only during explanation for better understanding and avoiding any confusion.
Again thanks for great explanation. Really appreciate the time you have taken to explain the DP concepts.
I have no idea what complete dynamic programming is, nor do I ever imagine I'll ever learn, but I did somehow wake up at 3am from a very bizzare dream about it due to youtube's autoplay. So thanks youtube for the 3am lesson that I didn't ask for.
same lmao
same lmao
I fell asleep listening to a podcast and then this came on afterwards. I had anxiety dreams I was in college again, and you were trying to teach me differential equations, but nothing you said made any sense because this isn't a class on DE.
I am soo glad that you are making a video on graphs .It will be lot more helpful to many people if you make videos on problems involving greedy method like u made for topics such as trees, dynamic programming . Like where we need to use this approach. We have very less videos regarding this.
Definitely you are getting to 10k.cause once a person start watching you he is going to stick with you
my right ear enjoyed this stream very much, cant say the same for my left year though :)
I appreciate you putting out this free educational content, but a suggestion would be to try to stay focused while explaining your thought process. It's hard to follow along when mid-thought you reply to chat :(
Wow this seems like what ive been dying to find. I sure hope it is. I appreciate all your effort and sharing the knowledge my friend!
not know , but just know you've affected my life, and apparently tens of thousands of others, in an imnsely positive way. Thank you
please keep making topic streams
Dreamed of this annoying know-it-all from my previous job
He was "teaching" me things I already knew
He said "now I'm gonna teach you recursion"
And I replied I ALREADY KNOW WHAT THAT IS
And he flat out ignored me
Then he said "okay to learn recursion we're gonna use fibonacci's sequence. but first let's learn what fibonacci's sequence is"
I was like NO I KNOW WHAT IT IS but again he ignored me
Eventually I was fed up so I left the room
But he CALLED ME and kept explaining fibonacci's sequence
Then I woke up and found out UA-cam was playing this random programming tutorial
So I just realized something after see you do Mashup B. One of the big parts of my struggle with DP questions is understanding what the heck the question is really asking. I saw the solution to the number of typeable substrings for the example string "abacaba" is 12, and I could not see how there are 12 substrings. I could only count 5:
a
ab
aba
ba
b
I couldn't fathom how there's 12 until like the next day I took a look again and it occurred to me that they're counting the same character multiple times if it's in the string in different places. So they're not looking for the count of unique substrings, which was pretty counterintuitive for me
Thanks for these vids man! One suggestion - The audio quality is a dampener to the amazing efforts you're putting in. If it's a short video, it's bearable, but in long streams like these, audio is actually way more important than video. If you could invest a bit in a better mic, it would do a world of good to up the quality of audio. Thanks again for your efforts and value addition to the community. Learning a ton from you!
Yep, this is an older video, and I have a much better mic for some of the newer ones.
@@ColinGalen I need help, for mashup A, I do get 2*f(n-2), do to probability, but I don’t get f(n-2) + f(n-2) and how you got that solution using DP
I incredibly doubt you will see this due to the fact that you apparently have a ton of subscribers all of a sudden, but thought you'd get a kick out of me having found this video through autoplay while asleep, you can imagine my surprise when I woke up and I heard a voice I recognized.
Thanks a lot it really helped.. Hoping to see more of these streams :)
will you conduct more such?
highly needed bruh!
Yeah, I do plan more in the future, there's just not much time for me to do them currently.
what an incredible video, hope you the best.
Thank you so much! I learnt a lot in all of your tutorial stream
F can be easily be solved using dearrangements!
Next one on graphs and trees🤔
thanks for your helpful lecture
Please do a topic stream on recursion and backtracking.
First few problems be like: "Imagine doing the O(1) solution when there's an O(n) solution"
FFT is not DP. It uses the decimation algorithm because so many of the elements end up being zeros. It can be 'memoized' but to break it up into smaller subproblems doesn't give any benefit.
Yeah, the algo got me here. It was on autoplay while I was sleeping.
5:41
"No Way!"
t'was funny 😂😂
You must be working with Python, I guess?
Robots and Relays.
How easily this dude gets distracted while talking is insane
I slept with UA-cam on and this video started playing. I dreamt about a guy who was solving the Navier Stokes millennium equation using some sort of toy that he moves around with his fingers (that was you typing). Lmao
😂😂😂😂😂😂😂😂😂😂😂
In problem A, f(n) = 2f(n-2) because we choose a 2x3 block (which has 2 orientations) and multiply with the solution of f(n-2), hence 2f(n-2). But we can also chose that 2x3 block in n ways, so why isn't the relation f(n) = n*2*f(n-2) ?
Because the location of the block is irrelevant - if you put it somewhere in the middle, it'll be equivalent to putting it in the middle later (i.e. the order in which you place down blocks is irrelevant). So that recurrence will drastically overcount. I use the recurrence I do to make the subproblems independent - if I place it at the (right) end of the current grid, then it will be completely independent from the rest of the grid, and thus not overcount.
@@ColinGalen Makes sense. Thanks for clearing this
Problem F should be more suitable in Math category rather than DP.
i am still not able to get the C problem can any one suggest a place to read it again
Couldn't understand some problems clearly....you could have explained some problems in more details....don't recommend this for beginners 😔..
what? Discord LIGHT THEME ???
ikr its blinding
theres very very very little amount of resources on the internet that help people from 0-100 with constructive resources and telling them what to drill and practice.
Only 30k left until he can pin comments
Since you have crossed more than 5k subs, you should now switch to something like electronic writing pad I guess.
soon™
what is he using in this video to write
@@cpwithsundar ms paint
Hey @ColinGalen I did not understood why are you using min() in mashup C's ?
@Colin Galen In problem E(office keys) Can you please help me in formally proving that the greedy way of having continuous assignment between the keys and people is optimum. Anyone's help would be really useful.
Lets say P1 and P2 are positions of two people and k1 and k2 are positions of two Keys
I am going to explain one of the case when k1>P1 and k2 > P2, other 3 cases you can deduce by yourself
Distance if we assign P1 to k2 and P2 to k1 is
K2-P1 + (p2-k1) if we assume P2> k1
Surely this dis is greater than
K1-p1 + (p2-k2) because P2>k1
Other cases you can prove similarly
Thank you!!!
Hi Colin, In problem E-Office Keys, I understand why you say two people can't cross their paths to get the keys. But you didn't say why you choose key positions continuously. I mean if first person is assigned to ith key position, second person is assigned to (i+1)th position and so on. What is the reason for this ?
The second person is not assigned to the (i+1)th position, he has the CHOICE to choose the (i+1)th position and any key after that
golden voice
Can you please provide some resource or some intuition for "taking continuous keys will give us optimal solution" part of E problem Office Keys
As soon as I heard the word math I went "nope"
It took 1 month to complete dp where some people trying to learn dp in one day ..... :D
i do not understand the dth question in that we can keep him awake for k straight minutes and if we choose start of 3 then we can keep him awake till [3,3+3-1] which includes 5 2 5 so the sum is 12 but how sum is coming as 14 please help ?
How do I get the list of all the codeforces mashups which you have created!
I think you don't know what is row and what is column?
Hello, in the past couple of days my internet started acting very strange, my lights are a solid green and a blinking orange but whenever i try to play an online game i keep getting disconnected but the little icon in the right corner still says in connected, how can i fix this?
thank you very much!❣️
Is this the extension or something else (the box with the right arrow) :)
Just checking this out
Nice Stream just avoid reading chats so much, they distract a lot rest all are fine
Why? It's his channel, he has the complete freedom to do streams the way he deems it fun as well as informative. It's no easy task doing a 4hr streaming without taking much of a break.
@@imranif3899 you are so cute
@@pleasesirmorevideos4684 lol...couldn't you just avoid reading my comment? So distracting, wasn't it? I highly doubt your ability to do what you just said.
@@imranif3899 you are still so cute
@@pleasesirmorevideos4684 Bruh, even if you know each other, don't be toxic
Hey colin can u plz teach line sweep algorithms with example plz.. Ur videos are awesome tho. Great work and i like the ways u teach. Best 👍
I am not comfortable using push dp. Is it ok to use recursive dp. I mean are there any questions which can be done by push dp and not with recursive dp?
Yes, there are some. However, they usually involve difficult recurrences, and won't show up until the higher end of the difficulty scale. In almost all cases, it's completely fine to use recursive DP, and whatever you use is preference. By the time you get to the point of having to solve the harder ones, you'll probably be comfortable enough with DP to be able to do it.
I woke up to this. How does someone end here starting from brawl stars kmak
You help me a lot
Please explain codechef november long questions
Hey, in problem A, shouldn't f[0] be 0, since a 3x0 grid doesn't make sense.
Hey Colin,
can you please make a video for beginners on how to become red on codeforces, thank you
Can u make a video on how do use templates
Why can't I join the MashUp GYMS(PROBLEMSETS)?
1:03:00 didnt understand the logic as to why f(i)= f(i-1)+1, if f(i) is the no of substrings ending with index i
same did you got the answer?
Why this people in the chat talk more about other shits than the problems in a topic stream ! It's irritating 😑
Bro I love your explanations but either stop doing live streams or don't talk to chat in the middle of a solution. Because when i watch recording out of 40 mins of a solution 20 mins is just random talks and its too annoying for us. Read chats when you switch between questions but not otherwise.
Galen colin in cp:🔥🔥🔥🔥🔥🔥
oh loawd im coming
Do you actually Questions like this or do it in the mind?
yeah it's good for me
Thanks!
ur too much into live chat!!...this turns irritating at a point
In problem E, office keys. Taking a contiguous segment of keys is always optimal. Can this lead to a better complexity than O(people * keys).
Try about 48k more hours, you're still a noob after this.
You're thinking woke me up.
Great!
do one for recursion
That is great
awesome stream colin
what is this IDE?
yt wtf. I fall asleep for 4h xD
Pls make more videos🙏
GLAD I MET HACKERS SUMMIT WHO SORTED MY GRADES ISSUES,THEY CAN HELP YOU
yeah i can really tell you are 17 right now. i couldn't sit for 10 seconds of this
Why the F*** did this interrupt my korean street food?????
@ColingGalen, do you drink coffee?
1:23:58
For personal use, please ignore
1:57:11
I set UA-cam on auto play when I was asleep… where the fuck am I?
dang microphone
Woow woow
This problem set is awful. Four problems in and none of them actually required dynamic programming to find a solution. In fact, all of them could be solved faster by paying attention and thinking the problem thru.
dynamic